#ifndef EFL_IO_POSITIONER_EO_HH
#define EFL_IO_POSITIONER_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_io_positioner.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { namespace io { 
struct Positioner;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::io::Positioner> : ::std::true_type {}; } }
namespace efl { namespace io { 
struct Positioner;
} } 

namespace eo_cxx {
namespace efl { namespace io { 
struct Positioner {
   ::efl::eolian::return_traits< uint64_t>::type position_get() const;
   ::efl::eolian::return_traits<bool>::type position_set( ::efl::eolian::in_traits< uint64_t>::type position) const;
   ::efl::eolian::return_traits<Eina_Error>::type seek( ::efl::eolian::in_traits< int64_t>::type offset,  ::efl::eolian::in_traits<Efl_Io_Positioner_Whence>::type whence) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_IO_POSITIONER_MIXIN;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::io::Positioner() const;
   operator ::efl::io::Positioner&();
   operator ::efl::io::Positioner const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Positioner> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Positioner const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace io { 
struct Positioner : ::efl::eo::concrete
{
   explicit Positioner( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Positioner(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Positioner(Positioner const& other) = default;
   Positioner(Positioner&& other) = default;
   Positioner& operator=(Positioner const& other) = default;
   Positioner& operator=(Positioner&& other) = default;
   Positioner()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Positioner( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Positioner(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits< uint64_t>::type position_get() const;
   ::efl::eolian::return_traits<bool>::type position_set( ::efl::eolian::in_traits< uint64_t>::type position) const;
   ::efl::eolian::return_traits<Eina_Error>::type seek( ::efl::eolian::in_traits< int64_t>::type offset,  ::efl::eolian::in_traits<Efl_Io_Positioner_Whence>::type whence) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_IO_POSITIONER_MIXIN;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct position_changed_event
   {
      static Efl_Event_Description const* description()
      { return EFL_IO_POSITIONER_EVENT_POSITION_CHANGED; }
      typedef void parameter_type;
   } const position_changed_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Positioner> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Positioner const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Positioner) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Positioner>::value, "");
} } 
#endif
